<template>
  <Dialog :title="dialogTitle" v-model="dialogVisible">
    <el-form
      ref="formRef"
      :model="formData"
      :rules="ifAlone==null?aloneFormRules:formRules"
      label-width="100px"
      v-loading="formLoading"
    >
      <el-form-item label="供应商" prop="supplierId" v-if="ifAlone==null">
        <el-select v-model="formData.supplierId" filterable placeholder="请选择">
          <el-option
            v-for="dict in supplierList"
            :key="dict.id"
            :label="dict.name"
            :value="dict.id"
          />
        </el-select>
      </el-form-item>
      <el-form-item label="姓名" prop="name">
        <el-input v-model="formData.name" placeholder="请输入姓名" />
      </el-form-item>
      <el-form-item label="电话" prop="telephone">
        <el-input v-model="formData.telephone" placeholder="请输入电话" />
      </el-form-item>
      <el-form-item label="职务" prop="position">
        <el-input v-model="formData.position" placeholder="请输入职务" />
      </el-form-item>
      <el-form-item label="邮箱" prop="email">
        <el-input v-model="formData.email" placeholder="请输入邮箱" />
      </el-form-item>
      <el-form-item label="产品业务模块" prop="productIds">
        <el-select v-model="formData.productIds" filterable placeholder="请选择">
          <el-option
            v-for="dict in productList"
            :key="dict.id"
            :label="dict.name"
            :value="dict.id"
          />
        </el-select>
      </el-form-item>
      <el-form-item label="备注" prop="remark">
        <el-input type="textarea" v-model="formData.remark" placeholder="请输入备注" />
      </el-form-item>
    </el-form>
    <template #footer>
      <el-button @click="submitForm" type="primary" :disabled="formLoading">确 定</el-button>
      <el-button @click="dialogVisible = false">取 消</el-button>
    </template>
  </Dialog>
</template>
<script setup lang="ts">
import { ContactApi, ContactVO } from '@/api/supplier/contact'
import {SupplierVO} from "@/api/supplier/base";
import * as SupplierBaseApi from "@/api/supplier/base";
import {FormRules} from "element-plus";
import * as SupplierDetailApi from '@/api/supplier/product/supplierdetail'

/** 供应商联系人 表单 */
defineOptions({ name: 'ContactForm' })

const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗
const supplierList = ref([] as SupplierVO[])
const productList = ref([] as SupplierProductVo[])
const dialogVisible = ref(false) // 弹窗的是否展示
const dialogTitle = ref('') // 弹窗的标题
const formLoading = ref(false) // 表单的加载中：1）修改时的数据加载；2）提交的按钮禁用
const formType = ref('') // 表单的类型：create - 新增；update - 修改
const formData = ref({
  id: undefined,
  supplierId: undefined,
  name: undefined,
  position: undefined,
  telephone: undefined,
  email: undefined,
  productIds: undefined,
  productNames: undefined,
  remark: undefined,
  supplierName: undefined
})
const formRules = reactive<FormRules>({
  // supplierId: [{ required: true, message: '供应商不能为空', trigger: 'blur' }],
  name: [{ required: true, message: '姓名不能为空', trigger: 'blur' }],

  email: [
    {
      type: 'email',
      message: '请输入正确的邮箱地址',
      trigger: ['blur', 'change']
    }
  ],
  telephone: [{ required: true, message: '电话不能为空', trigger: 'blur' },
    {
      pattern: /^(?:(?:\+|00)86)?1(?:3[\d]|4[5-79]|5[0-35-9]|6[5-7]|7[0-8]|8[\d]|9[189])\d{8}$/,
      message: '请输入正确的手机号码',
      trigger: 'blur'
    }
  ]
})
const aloneFormRules = reactive<FormRules>({
  supplierId: [{ required: true, message: '供应商不能为空', trigger: 'blur' }],
  name: [{ required: true, message: '姓名不能为空', trigger: 'blur' }],

  email: [
    {
      type: 'email',
      message: '请输入正确的邮箱地址',
      trigger: ['blur', 'change']
    }
  ],
  telephone: [{ required: true, message: '电话不能为空', trigger: 'blur' },
    {
      pattern: /^(?:(?:\+|00)86)?1(?:3[\d]|4[5-79]|5[0-35-9]|6[5-7]|7[0-8]|8[\d]|9[189])\d{8}$/,
      message: '请输入正确的手机号码',
      trigger: 'blur'
    }
  ]
})
const formRef = ref() // 表单 Ref
const props = defineProps({
  supplierId: { type: Number, default: () => null },
  ifAlone: { type: Boolean, default: () => null },
})
/** 打开弹窗 */
const open = async (type: string, id?: number) => {
  dialogVisible.value = true
  dialogTitle.value = t('action.' + type)
  formType.value = type
  resetForm()
  // 修改时，设置数据
  if (id) {
    formLoading.value = true
    try {
      formData.value = await ContactApi.getContact(id)
    } finally {
      formLoading.value = false
    }
  }
  supplierList.value = await SupplierBaseApi.Api.getAll()
  productList.value = await SupplierDetailApi.getAll()
}
defineExpose({ open }) // 提供 open 方法，用于打开弹窗

/** 提交表单 */
const emit = defineEmits(['success']) // 定义 success 事件，用于操作成功后的回调
const submitForm = async () => {
  // 校验表单
  await formRef.value.validate()
  // 提交请求
  formLoading.value = true
  try {
    const data = formData.value as unknown as ContactVO
    if (props.ifAlone!=null) {
      if (!props.supplierId.receivedParam){
        message.error("请先保存供应商基本信息");
        return
      }
      data.supplierId = props.supplierId.receivedParam
    }
    if (formType.value === 'create') {
      await ContactApi.createContact(data)
      message.success(t('common.createSuccess'))
    } else {
      await ContactApi.updateContact(data)
      message.success(t('common.updateSuccess'))
    }
    dialogVisible.value = false
    // 发送操作成功的事件
    emit('success')
  } finally {
    formLoading.value = false
  }
}

/** 重置表单 */
const resetForm = () => {
  formData.value = {
    id: undefined,
    supplierId: undefined,
    name: undefined,
    position: undefined,
    telephone: undefined,
    email: undefined,
    productIds: undefined,
    productNames: undefined,
    remark: undefined
  }
  formRef.value?.resetFields()
}
</script>
